<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: ref.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ref.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2010  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_REFERENCE_WRAPpER_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_REFERENCE_WRAPpER_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;{</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keyword">template</span>&lt;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        &gt; </div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classdlib_1_1reference__wrapper.html">   14</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper</a> </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    {</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classdlib_1_1reference__wrapper.html#a48a844cd6c909b48568d193dfe68590f">   23</a></span>&#160;        <span class="keyword">typedef</span> T <a class="code" href="classdlib_1_1reference__wrapper.html#a48a844cd6c909b48568d193dfe68590f">type</a>;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keyword">explicit</span> <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper</a>(T&amp; o) : obj(&amp;o) {}</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keyword">operator</span> T&amp;()    <span class="keyword">const</span> { <span class="keywordflow">return</span>  *obj; }</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        T&amp; get()<span class="keyword">         const </span>{ <span class="keywordflow">return</span>  *obj; }</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        T* obj;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    };</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    reference_wrapper&lt;T&gt; ref(</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        T&amp; obj</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    ) { <span class="keywordflow">return</span> reference_wrapper&lt;T&gt;(obj); }</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="namespacedlib.html#a350fb1a49c66158c84bed8468698f145">   48</a></span>&#160;    <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;T&gt;</a> ref(</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;T&gt;</a> obj</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    ) { <span class="keywordflow">return</span> obj; }</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="namespacedlib.html#a4f7044e2194dfbd6473b90d75efe2fbc">   59</a></span>&#160;    <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;const T&gt;</a> <a class="code" href="namespacedlib.html#a4f7044e2194dfbd6473b90d75efe2fbc">cref</a>(</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> T&amp; obj</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    ) { <span class="keywordflow">return</span> <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;const T&gt;</a>(obj); }</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="namespacedlib.html#a647721498a0ea68f29129c71991b0dcd">   70</a></span>&#160;    <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;const T&gt;</a> <a class="code" href="namespacedlib.html#a4f7044e2194dfbd6473b90d75efe2fbc">cref</a>(</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <a class="code" href="classdlib_1_1reference__wrapper.html">reference_wrapper&lt;T&gt;</a> obj</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    ) { <span class="keywordflow">return</span> <a class="code" href="namespacedlib.html#a4f7044e2194dfbd6473b90d75efe2fbc">cref</a>(obj.get()); }</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif // DLIB_REFERENCE_WRAPpER_H_</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1reference__wrapper_html_a48a844cd6c909b48568d193dfe68590f"><div class="ttname"><a href="classdlib_1_1reference__wrapper.html#a48a844cd6c909b48568d193dfe68590f">dlib::reference_wrapper::type</a></div><div class="ttdeci">T type</div><div class="ttdef"><b>Definition:</b> ref.h:23</div></div>
<div class="ttc" id="aclassdlib_1_1reference__wrapper_html"><div class="ttname"><a href="classdlib_1_1reference__wrapper.html">dlib::reference_wrapper</a></div><div class="ttdef"><b>Definition:</b> ref.h:14</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<div class="ttc" id="anamespacedlib_html_a4f7044e2194dfbd6473b90d75efe2fbc"><div class="ttname"><a href="namespacedlib.html#a4f7044e2194dfbd6473b90d75efe2fbc">dlib::cref</a></div><div class="ttdeci">reference_wrapper&lt; const T &gt; cref(const T &amp;obj)</div><div class="ttdef"><b>Definition:</b> ref.h:59</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
